/*
  Projekt: Jak na projekty v jazyce C

  Zkladn konstrukce jazyka C
  Lekce 3 - ukazatele

  Autor: David Martinek, martinek (zavin) fit.vutbr.cz
  Datum: 12.03.2009
  Kdovn dokumentu: ISO8859-2
  Popis: Tento program slou pro demonstraci zkladnch stavebnch prvk
         jazyka C.
  Webov adresa: http://www.fit.vutbr.cz/~martinek/clang/
*/

// Jak st tento zdrojov soubor
// 1. Zante sekc pro vkldn rozhran knihoven.
// 2. Podvejte se na funkci main, kter se nachz na konci souboru.
// 3. Ve funkci main se v uritm poad volaj jednotliv podprogramy.
//    V tom poad, v jakm se volaj ve funkci main, si prohldnte jejich
//    definice v prostedn sti zdrojovho souboru. Ped kadou funkc se
//    nachz koment, kter vysvtluje, co se v tto funkci dje.
// 4. Pelote tento zdrojov soubor pomoc pekladae jazyka C. Na webovch
//    strnkch Jak na projekty v jazyce C najdete postup, jak peklada
//    zavolat.
//    Tak mete pout pkaz make. Makefile je pibalen. Pokud nerozumte,
//    co to znamen, pette si o programu make na webovch strnkch.


////////// Sekce pro vkldn rozhran knihoven ///////////////////////////////
#include <stdio.h>
#include <stdlib.h>

///////// Definice konstant ///////////////////////////////////////////////////
// symbolick konstanta
#define DELKA 10

///////// Definice podprogram ////////////////////////////////////////////////

//== zatek = ukazatele na lokln promnn ==
/**
 * Funkce pro demonstraci prce s ukazateli na jednoduch datov typy.
 *
 * Ukazatel je speciln seln datov typ. Promnn typu ukazatel obsahuj
 * cel slo, kter je interpretovno jako adresa urit pamov buky.
 * Obvykle pracujeme s tzv. typovmi ukazateli, tedy ukazateli na int, double,
 * char, atd. Takovmu clovmu typu se k bzov typ ukazatele a slou
 * k tomu, abychom vdli, na jak velkou st pamti od dan adresy se mme
 * podvat. Nap. typ int * je ukazatel na tybajtov int, tedy adresa ukazuje
 * na konkrtn msto v pamti (buku o velikosti 1 bajt) a peklada v, e
 * me pracovat s nsledujcmi tymi bajty.
 */
void simplePointers(void)
{
  int promenna = 1234; // promnn typu int obsahujc hodnotu 1234
  // definice lokln promnn typu ukazatel na int
  // nyn obsahuje nhodnou adresu, nelze ji tedy rozumn pout
  int *ukazatel;

  // nyn zkoprujeme do promnn ukazatel adresu promnn promenna
  // & je tzv. referenn opertor - vrac adresu svho argumentu
  ukazatel = &promenna;

  // nyn vytvome druhou promnnou typu ukazatel na int
  // a zkoprujeme do n obsah promnn ukazatel
  // druhyUk nyn obsahuje rovn adresu promnn promenna
  // kme, e ukazuje na promnnou promenna
  int *druhyUk = ukazatel;

  // ukazatele, tedy adresy lze porovnvat
  if (ukazatel == druhyUk)
  {
    printf("Oba ukazatele ukazuj na stejn msto v pamti.\n");
  }

  // Pomoc opertoru * se umme podvat na msto, na kter ukazatel ukazuje.
  // * je tzv. dereferenn opertor - vrac hodnotu, na kterou ukazatel ukazuje
  // Datov typ vsledku je uren bzovm typem ukazatele, take pokud ukazatel
  // ukazuje na int, je vsledek opertoru * tak typu int.
  printf("promenna = %d, *ukazatel = %d, *druhyUk = %d\n",
    promenna, *ukazatel, *druhyUk);

  // Obsah promnn promenna lze nyn modifikovat temi zpsoby.
  // 1. pmou zmnou  promnn promenna
  promenna = 987;
  printf("promenna = %d, *ukazatel = %d, *druhyUk = %d\n",
    promenna, *ukazatel, *druhyUk);

  // 2. pes promnnou ukazatel pomoc dereferennho opertoru
  *ukazatel = 654;
  printf("promenna = %d, *ukazatel = %d, *druhyUk = %d\n",
    promenna, *ukazatel, *druhyUk);

  // 3. pes promnnou druhyUk opt pomoc dereferennho opertoru
  *druhyUk = 357;
  printf("promenna = %d, *ukazatel = %d, *druhyUk = %d\n",
    promenna, *ukazatel, *druhyUk);


  // Ukazatele na rzn bzov typy jsou vzjemn kompatibiln jenom tak, jak
  // jsou vzjemn kompatibiln tyto bzov typy.
  // V tomto ppad by peklada vypsal varovn:
  // warning: initialization from incompatible pointer type
//  double *ukDouble = ukazatel;
  // Program by se sice nakonec peloil, ale dle v programu by toto mohlo
  // vst k zvanm chybm.

  // Ukazatele + return
  // POZOR! Funkce mohou vracet ukazatel, ale nikdy se nepokouejte vracet
  // ukazatel ukazujc na lokln promnnou! Lokln promnn po ukonen
  // funkce zanikaj, proto by vsledek takovto funkce nebyl pouiteln,
  // resp. jeho pouitm bychom zpsobili chybu bhu programu.

  // TIP: Pokud nemu nerozumte, zeptejte se nebo zkuste najt odpov ve
  // vhodn uebnici jazyka C.
}

//== konec = ukazatele na lokln promnn ==

//== zatek = ukazatele a lokln pole ==

/**
 * Pomocn funkce pro tisk obsahu pole na standardn vstup.
 *
 * Vimnte si, e parametr pole se pedv jako ukazatel na bzov typ int
 * a dle se s nm pracuje jako s polem.
 *
 * Dle si vimnte, e je nutn pedat jako dal parametr poet prvk pole,
 * protoe datov typ pole si poet svch prvk nepamatuje.
 *
 * TIP: Datov typ pole v jazyce C si nepamatuje, ani neme pamatovat svou
 *      dlku. Zamyslete se nad tm, pro tomu tak je.
 */
void tiskPole(char * text, int *pole, int delka)
{
  printf("%s { ", text);
  for (int i = 0; i < delka; ++i)
  {
    printf("%d, ", pole[i]);
  }
  printf("}\n");
}

/**
 * Funkce pro demonstraci vztahu mezi ukazateli a loklnmi poli.
 *
 */
void lokalniPole(void)
{

  // neinicializovan ukazatel
  int *uk;

  // neinicializovan jednorozmrn pole
  int mocniny[DELKA];

  // podvme se, co pole skuten obsahuje
  // vimnte si, jak se pole pedv funkci tiskPole
  tiskPole("mocniny = ", mocniny, DELKA);

  // inicializace pole
  for (int i = 0; i < DELKA; ++i)
  {
    mocniny[i] = i*i;
  }
  // podvme se, co pole skuten obsahuje po inicializaci
  tiskPole("mocniny = ", mocniny, DELKA);

  // kopie ukazatele - samotn identifiktor pole m vznam ukazatele na
  // zatek pole
  // od tto chvle lze s ukazatelem uk pracovat stejn jako s polem
  // POZOR! Zde se nevytv kopie pole! Pole zstv v pamti jen jednou.
  //        Zde se kopruje ukazatel, take k jednomu poli pak jde pistupovat
  //        ze dvou mst - pes identifiktory uk a mocniny.
  uk = mocniny;
  tiskPole("uk = ", uk, 10);

  // pes ukazatel meme pole modifikovat
  // nyn vyrobme posloupnost tetch mocnin celch sel
  for (int i = 0; i < DELKA; ++i)
  {
    uk[i] = uk[i] * i; // nebo takto: uk[i] *= i;
  }

  tiskPole("uk = ", uk, 10);

  // POZOR! Opan to nejde! Do promnn typu pole NELZE nic piadit
  // pole = uk; // toto peklada odhal jako syntaktickou chybu
}

/**
 * Funkce pro demonstraci toho, jak se daj koprovat lokln, jednorozmrn
 * pole.
 */
void kopieLokalnichPoli(void)
{
  // dv lokln, neinicializovan pole
  int pole1[DELKA], pole2[DELKA];

  // inicializace
  for (int i = 0; i < DELKA; ++i)
  {
    pole1[i] = i + 1;
  }

  tiskPole("pole1 = ", pole1, DELKA);

  // pole nelze koprovat pouhm piazenm!
  // datov typ pole nezn svou dlku, take by peklada nevdl, kolik jak
  // velk sek pamti m koprovat
//  pole2 = pole1; // syntaktick chyba

  // musme postupovat prvek po prvku (nebo pout odpovdajc knihovn funkci)
  for (int i = 0; i < DELKA; ++i)
  {
    pole2[i] = pole1[i];
  }

  tiskPole("pole2 = ", pole2, DELKA);
}

//== konec = ukazatele a lokln pole ==


//== zatek = dynamick alokace ==

/**
 * Demonstrace dynamicky alokovanch promnnch.
 *
 * Lokln promnn jsou umstny v oblasti pamti zvan zsobnk. Pi definici
 * promnn se automaticky na zsobnku vyhrad potebn kus pamti a pi
 * ukonen bloku nebo funkce se tato pam zase automaticky uvoln - nen
 * poteba se o to starat. Nevhodou je, e lokln promnn nelze vynst
 * z funkce ven, protoe po jejm ukonen automaticky zanikaj. Velikost
 * zsobnku tak bv z bezpenostnch dvod omezena, take nelze vyut
 * vekerou dostupnou pam potae.
 *
 * Dynamicky alokovan promnn jsou umstny v oblasti pamti zvan hromada.
 * Tuto pam lze spravovat pouze run, pomoc voln knihovnch funkc
 * malloc a free. Tmto zpsobem lze vyut tm vekerou dostupnou pam
 * potae, ale programtor je sm zodpovdn za sprvnou alokaci pamti
 * i jej uvolnn, pokud u ji nepotebuje.
 */
void dynamickaAlokace(void)
{
  // neinicializovan ukazatel na int
  int *uCislo;

  // alokace pamti na hromad o velikosti jednoho intu
  // opertor sizeof vrac poet bajt, kter dan typ zabr
  // funkci malloc pouvejte VDY v kombinaci se sizeof
  // tmto pkazem alokujeme na hromad prostor pro jednu promnnou typu int
  uCislo = malloc(1*sizeof(int));

  // k nov alokovan promnn lze pistupovat pouze pomoc ukazatele, v naem
  // ppad uCislo
  // prozatm je hodnota alokovan pamov buky neinicializovan
  // k hodnot pamov buky na adrese uCislo se nyn dostaneme pomoc
  // dereferennho opertoru *
  printf("*uCislo = %d\n", *uCislo);
  *uCislo = 10;
  printf("*uCislo = %d\n", *uCislo);

  // dle tuto buku nebudeme potebovat, proto ji musme uvolnit pomoc
  // funkce free - vimnte si, e funkci free se pedv ukazatel
  free(uCislo);

  // Nyn je uCislo de facto neinicializovan ukazatel, resp. ukazuje do
  // nealokovan pamti. Odkaz pes takov ukazatel by zpsobil havrii.
  // stenm zmrnnm tohoto rizika je nastaven na hodnotu NULL, co je
  // przdn ukazatel. Odkaz pes nj vede tak k havrii, ale alespo takov
  // ukazatel meme otestovat, ne s nm nco provedeme (asto se takto
  // testuj parametry funkc).
  uCislo = NULL;


  // stejnm zpsobem meme na hromad alokovat pole
  // k pstupu k takto alokovanmu poli vyuijeme ukazatel
  // funkci malloc ekneme, aby alokovala pam o velikosti DELKA*sizeof(int)
  // bajt
  int *dynPole = malloc(DELKA*sizeof(int));

  // nyn je pole neinicializovan (nenechte se zmst, pokud v nm budou nuly,
  // je to jen nhoda)
  // vimnte si, e od tto chvle se s dynamicky alokovanm polem pracuje
  // stejn jako s loklnm
  tiskPole("dynPole = ", dynPole, DELKA);

  // inicializace
  for (int i = 0; i < DELKA; ++i)
  {
    dynPole[i] = i*i;
  }
  tiskPole("dynPole = ", dynPole, DELKA);

  // po skonen prce musme pole zase uvolnit
  free(dynPole);
}

/**
 * Demonstrace koprovn dynamickch pol.
 */
void kopieDynamickychPoli(void)
{
  // dv lokln promnn typu ukazatel na int
  int *pole1, *pole2;

  // alokujeme pole s dlkou delka
  pole1 = malloc(DELKA*sizeof(int));

  // inicializace
  for (int i = 0; i < DELKA; ++i)
  {
    pole1[i] = i + 1;
  }
  tiskPole("pole1 = ", pole1, DELKA);

  // toto je pouh kopie ukazatel, nikoli pol!
  // nyn budou na stejn pole ukazovat dva ukazatele
  pole2 = pole1;

  // udlme v poli zmnu pes ukazatel pole2, abychom vidli, e tato zmna
  // bude viditeln i pes ukazatel pole1
  pole2[5] = 9999;
  tiskPole("pole1 = ", pole1, DELKA);
  tiskPole("pole2 = ", pole2, DELKA);

  // skutenou kopii lze udlat pouze tak, e alokujeme prostor pro druh,
  // stejn dlouh pole a pak jej prvek po prvku zkoprujeme
  pole2 = malloc(DELKA*sizeof(int));
  for (int i = 0; i < DELKA; ++i)
  {
    pole2[i] = pole1[i];
  }
  tiskPole("pole1 = ", pole1, DELKA);
  tiskPole("pole2 = ", pole2, DELKA);

  // nyn mme skutenou kopii pole
  // aby bylo vidt, e oba ukazatele ukazuj na jin pole, provedeme v jednom
  // z nich zmnu
  pole2[2] = 888;
  tiskPole("pole1 = ", pole1, DELKA);
  tiskPole("pole2 = ", pole2, DELKA);

  // nakonec musme alokovanou pam uvolnit
  free(pole1);
  free(pole2);
}

//== konec = dynamick alokace ==

//== zacatek = operace s typem ukazatel ==
/**
 * Ukzka dalch operac nad datovm typem ukazatel. Bn pouvan jsou
 * piazen, indexovn, reference a dereference. Ostatn (porovnvn,
 * stn s celmi sly) NEPOUVEJTE dokud to nebude absolutn nezbytn,
 * protoe to obvykle vede k tko itelnm programm.
 */
void operaceNadUkazateli(void)
{
  // ukazatele lze koprovat piazovacm opertorem - kopruje se adresa!
  int *pole = malloc(DELKA*sizeof(int));

  // ukazatele lze indexovat
  for (int i = 0; i < DELKA; ++i)
  {
    if (i <= 1)
    { pole[i] = i; }
    else
    { pole[i] = pole[i-1] + pole[i-2]; }
  }
  tiskPole("pole = ", pole, DELKA);

  // ukazatele lze i porovnvat a pitat/odetat k nim cel slo
  // tomuto se k adresov aritmetika
  // POZOR! Tohle nepouvejte. Adresov aritmetika vede k obtn itelnmu
  // kdu, proto je takov program vce nchyln k chybm.
  // POZOR! Nepouvejte to jen proto, abyste udlali dojem. Pi obhajob
  // projektu tm spe vyprovokujete otzky, kter velmi dkladn prov
  // vae skuten znalosti!

  int *pozice = pole; // kopie ukazatel
  printf("Fibonacciho posloupnost: ");
  // piten sla k adrese znamen tot, co indexovn
  while (pozice < pole+DELKA) // porovnn ukazatel
  {
    printf(" %d ", *pozice); // dereference - zskn odkazovan hodnoty
    ++pozice; // posun na adresu dalho prvku v poli -- adresa = adresa + sizeof(int)
  }
  printf("\n");


  // Adresov aritmetiky se d tak pout pro pedn pouze sti pole do
  // podprogramu. Zde pedvme ukazatel na pole posunut o 3 prvky (tedy od
  // indexu 3) kme funkci, e m zpracovat nsledujc 4 prvky.
  // TIP: U jste si uvdomili, pro si pole neme pamatovat svou dlku?
  tiskPole("pole[3-6] = ", pole+3, 4);

  // Stejn meme zpracovvat textov etzce
  char * zprava = "Uvedomte si, ze jazyk C je fajn";
  printf("%s\n", zprava+16);

  // nyn uvolnme nepouvanou pam
  free(pole);
//  free(pozice); // Tohle by vedlo k havrii. Pro?

}
//== konec = operace s typem ukazatel ==

///////// Funkce main /////////////////////////////////////////////////////////

/**
 * Hlavn funkce programu. Zde se nachz startovac bod programu. Funkce
 * main se spust jako prvn pi sputn peloenho programu. Z tto funkce
 * se volaj vechny ostatn podprogramy.
 *
 * V tomto ppad jde o funkci bez parametr (to k klov slovo void),
 * kter vrac hodnotu typu int. Podle tto hodnoty operan systm, kter
 * tuto funkci zavolal, pozn, zda program skonil bez problm nebo jestli
 * nedolo k njak chyb.
 */
int main(void)
{
  printf("=== funkce simplePointers ===\n");
  simplePointers();

  printf("=== funkce lokalniPole ===\n");
  lokalniPole();

  printf("=== funkce kopieLokalnichPoli ===\n");
  kopieLokalnichPoli();

  printf("=== funkce dynamickaAlokace ===\n");
  dynamickaAlokace();

  printf("=== funkce kopieDynamickychPoli ===\n");
  kopieDynamickychPoli();

  printf("=== funkce operaceNadUkazateli ===\n");
  operaceNadUkazateli();


  return EXIT_SUCCESS;  // program kon bez chyby
}
